#!/bin/sh

echo -e "\nWelcome to the tiny configurator of kernsh-0.2b"
echo "=================================================="
echo -e "\nShould work on a 2.2 and 2.4 kernels"
echo -e "Never forget that you are the ultimate tool :)"
echo

SRC="/lib/modules/`uname -r`/build"

read -p "Where are your kernel sources located ? [$SRC] " KSRC
case $KSRC in
	"")
		IFLAGS=-I$SRC/include
		;;
	*)
		IFLAGS=-I$KSRC/include
		;;
esac

echo -n "Checking for RH systems : "
if [ -e /etc/redhat-release -o -e /etc/redhat_release ];
then
	echo "Yes"
	read -p "Do you use a kernel from RH ? [Y/n] " KRH
	case $KRH in
		n|N|No|no)
			;;
		*)
			CFLAGS=-D_RH_
			;;
	esac
else
	echo "no"
fi

LIB=termcap

read -p "Do you use the termcap or ncurses library ? [$LIB] " KLIB
case $KLIB in
	"")
		LFLAGS=-l$LIB
		;;
	*)
		LFLAGS=-l$KLIB
		;;
esac

read -p "Do you want to do debugging (valgrind for example) ? [y/N] " KDEB
case $KDEB in
	Y|y|yes|Yes)
		CFLAGS="$CFLAGS -g -ggdb -DDEBUG"
		echo "WARNING !!! Don't report  Bugs when using these flags !!"
		echo "All the idt stuff will be not  functionnal with the -DDEBUG"
		echo "Flag ! ( if you want only -g -ggbb edit Makefile.in )"
		sleep 2
		;;
	*)
		;;
esac

echo -n "Writing Makefile.in : "
echo -e "IFLAGS =\t$IFLAGS" > Makefile.in
echo -e "CFLAGS =\t$CFLAGS" >> Makefile.in
echo -e "LFLAGS =\t$LFLAGS" >> Makefile.in
echo -e "KV=`uname -r`" >> Makefile.in
echo "done"

echo -e "\nNow you can compile kernsh with make"
echo "Thank you for using kernsh and happy hunting !"

exit 0

