/* Little prog for handling with the kad_stub loaded by kernsh (wainting for the syscall -c with arguments :) -- Kstat*/
#include "shared.h"
#include <stdlib.h>
#include <stdio.h>

__asm__(
"       .globl do_syscall               \n"
"	.align 4,0x90			\n"
"       syscall:	                \n"
"               push %ebx               \n"
"               push %ecx               \n"
//argv start at esp-12 coz we push ebx and ecx before
"               mov 12(%esp),%eax       \n"
"               mov 16(%esp),%ebx       \n"
"               mov 20(%esp),%ecx       \n"
"		mov 24(%esp),%edx	\n"
"		mov 28(%esp),%edi	\n"
"               int $0x80               \n"
"               pop %ecx                \n"
"               pop %ebx                \n"
"               ret                     \n"
);

void
usage()
{
	fprintf(stdout,"handle hook [prog_name] [ord_str] [old_str] | list | unhook [list_num] | uninstall\n"
			"Uninstall is needed in order to make kernsh working (temporary measure)\n");
	exit(1) ;
}

int main(int argc, char **argv)
{
char *data;
int x;

if(argc < 2)
    usage();

if(!strcmp(argv[1],"hook"))
    {
    if(argc < 5)
	usage();

    syscall(SYS_HIJACK,ADD_HIJACK,argv[2],argv[3],argv[4]);
        
    return 0;
    }

if(!strcmp(argv[1],"unhook"))
    {
    if(argc < 3)
	usage();
    
    x = (char)argv[2][0];
    
    syscall(SYS_HIJACK,DEL_HIJACK,x);

    return 0;
    }

if(!strcmp(argv[1],"list"))
    {
    data  = (char *) malloc(800);
    bzero(data,800);
        
    syscall(SYS_HIJACK,LIST_HIJACK,data);

    printf("%s",data);
    
    free(data);
    return 0;
    }

if(!strcmp(argv[1],"uninstall"))
    {
    syscall(SYS_HIJACK,UNINSTALL_HIJACK);
    return 0;
    }

usage();

return 0;
}


