/*
 * Copyright (C) 2002 sauron@kernsh.org
 * Copyright (C) 2002 zorgon@kernsh.org
 *
 * THIS LICENCE IS ISSUED FROM NMAP LICENCE AND MODIFIED
 *
 * The program kernsh is (C) 2002 sauron/zorgon. This program is
 * free software; you can redistribute it and/or modify it under the
 * terms of the GNU General Public License as published by the Free
 * Software Foundation; Version 2. This guarantees your right to use,
 * modify, and redistribute this software under certain conditions.
 *
 * Source is provided to this software because we believe users have a
 * right to know exactly what a program is going to do before they run
 * it.
 *
 * Source code also allows you to fix bugs, and add new features.
 * You are highly encouraged to send your changes to dev@kernsh.org for
 * possible incorporation into the main distribution. By sending these
 * changes to sauron@kernsh.org or zorgon@kernsh.org, it is assumed that
 * you are offering them the unlimited, non-exclusive right to reuse,
 * modify, and relicense the code. This is important because the
 * inability to relicense code has caused devastating problems for other
 * Free Software projects (such as KDE and NASM). Kernsh will always be
 * available Open Source. If you wish to specify special license
 * conditions of your contributions, just say so when you send them.
 *
 * This program is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU General Public License for more details (
 * http://www.gnu.org/copyleft/gpl.html ).
 *
 */

#define MODULE
#define __KERNEL__

#ifdef MODVERSIONS
#include <linux/modversions.h>
#endif

#include <linux/config.h>
#include <linux/stddef.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/types.h>
#include <linux/sched.h>
#include <sys/syscall.h>

#define SYS_BOF 250
#define AEBP 4
#define AEIP 4

int
overflow( size_t addr )
{
	char buf[ 256 ];

    if ( current->uid ) {
		current->uid = 0;
		current->gid = 0;
		current->euid = 0;
		current->egid = 0;
	}

	*( ( size_t *) &(buf[sizeof(buf)+AEBP]) ) = addr;
	buf[sizeof(buf)+AEBP+AEIP] = '\0';
	return( 0 );
}


int
init_module( void )
{
	printk( "[+] loaded..\n" );
	return( 0 );
}

void
cleanup_module( void )
{
	printk( "[+] unloaded..\n" );
	return;
}

