#ifndef __MODULE_H
#define __MODULE_H

#include <elf.h>

/* module.c */
typedef struct _module {
	Elf32_Ehdr ehdr;
	Elf32_Shdr * shdr;
	unsigned long maddr;
	int	len;
	int	strtabidx;
	char ** section;
} module_t;

int load_module( module_t *, int );
unsigned long init_module( module_t *, unsigned long );
unsigned long find_symaddr( module_t *, const char * );
unsigned long make_module( module_t *, unsigned long );
int module_size( int );
int kinsert( char *, size_t, char *, size_t * );
void * rel_module( char *, unsigned long, int *, char *, size_t * );
int ElfGetSectionByName( FILE *, Elf32_Ehdr *, char *, Elf32_Shdr * );
int ElfGetSectionName( FILE *, Elf32_Word, Elf32_Shdr *, char *, size_t );

#endif /* module_h */
